//-----------------------------------------------------------------------------
// File: grbrsize.h
//
// Desc: Grabber demo capture size code based on the Microsoft Playcap Sample.
//
// 12/08/15 Advanced Micro Peripherals Ltd.
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// File: playcap.h
//
// Desc: DirectShow sample code - header file for PlayCap previewer
//       application.
//
// Copyright (c) 1998-2001 Microsoft Corporation.  All rights reserved.
//-----------------------------------------------------------------------------

#include "resource.h"

//-----------------------------------------------------------------------------
// Function prototypes
//
int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hInstP, LPSTR lpCmdLine, int nCmdShow);
LRESULT CALLBACK WndMainProc (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam);
int FAR PASCAL SetupValsProc(HWND hwnd, UINT msg, UINT wParam, LONG lParam);

HRESULT GetInterfaces(void);
void CloseInterfaces(void);
HRESULT FindCaptureDevice(IBaseFilter ** ppSrcFilter, int index);
HRESULT FindOverlayMixer(IBaseFilter ** ppOverlay);
HRESULT BuildGraph(void);
HRESULT Capture(void);
HRESULT SetupVideoWindow(void);
void ResizeVideoWindow(void);
HRESULT ChangePreviewState(int nShow);
void Msg(TCHAR *szFormat, ...);
void RouteVideo(void);
void SetTV(void);
HRESULT HandleGraphEvent(void);

HRESULT GraphicsQuickDemo(void);
HRESULT GraphicsRawDemo(void);
HRESULT TextQuickDemo(void);

// Remote graph viewing functions
HRESULT AddGraphToRot(IUnknown *pUnkGraph, DWORD *pdwRegister);
void RemoveGraphFromRot(DWORD pdwRegister);

enum PLAYSTATE {Stopped, Paused, Running, Init};

//-----------------------------------------------------------------------------
// Macros
//
#define SAFE_RELEASE(x) { if (x) x->Release(); x = NULL; }
#define SAFE_FREE(x)	{ if (x) free(x); x = NULL; }

#define JIF(x) if (FAILED(hr=(x))) \
    {Msg(TEXT("FAILED(hr=0x%x) in ") TEXT(#x) TEXT("\n"), hr); return hr;}

//-----------------------------------------------------------------------------
// Constants
//
#define APPLICATIONNAME TEXT("Video Capture Previewer")
#define CLASSNAME       TEXT("VidCapPreviewer")

// Application-defined message to notify app of filtergraph events
#define WM_GRAPHNOTIFY  WM_APP+1


